/*
	Project : MARCEL_CRUD_2
	File : AdminuserManage.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.tutorialspoint.com/hibernate/hibernate_examples.htm
	Notes : 
*/
package org.action;

import java.util.List; 
import java.util.Date;
import java.util.Iterator; 
 
import org.hibernate.HibernateException; 
import org.hibernate.Session; 
import org.hibernate.Transaction;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;

import org.model.Adminuser;

public class AdminuserManage {
	private static SessionFactory factory; 

	public static void main(String[] args) {
		try {
			factory = new Configuration().configure().buildSessionFactory();
		} catch (Throwable ex) { 
			System.err.println("Failed to create sessionFactory object." + ex);
			throw new ExceptionInInitializerError(ex); 
		}

		AdminuserManage ME = new AdminuserManage();

		/* Add few adminuser records in database */
		Integer empID1 = ME.addAdminuser("code01", "passwd1");
		Integer empID2 = ME.addAdminuser("code02", "passwd2");
		Integer empID3 = ME.addAdminuser("code03", "passwd3");

		/* List down all the adminusers */
		ME.listAdminusers();

		/* Update adminuser's records */
		ME.updateAdminuser(empID1, "passwd11");

		/* Delete an adminuser from the database */
		ME.deleteAdminuser(empID2);

		/* List down new list of the adminusers */
		ME.listAdminusers();
	}

	/* Method to CREATE an adminuser in the database */
	public Integer addAdminuser(String admincode, String password){
		Session session = factory.openSession();
		Transaction tx = null;
		Integer adminuserID = null;
		try {
			tx = session.beginTransaction();
			//Adminuser adminuser = new Adminuser(admincode, password);
			Adminuser adminuser = new Adminuser();
			adminuser.setAdmincode(admincode);
			adminuser.setPassword(password);
			adminuserID = (Integer) session.save(adminuser); 
			tx.commit();
		} catch (HibernateException e) {
			if (tx!=null) tx.rollback();
				e.printStackTrace(); 
		} finally {
		 session.close(); 
		}
		return adminuserID;
	}

	/* Method to  READ all the adminuser */
	public void listAdminusers() {
		Session session = factory.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			List<Adminuser> adminusers = session.createQuery("FROM Adminuser").list(); 
			for (Iterator<Adminuser> iterator = adminusers.iterator(); iterator.hasNext(); ) {
				Adminuser adminuser = iterator.next(); 
				System.out.print("First Name: " + adminuser.getAdmincode()); 
				System.out.print("  Last Name: " + adminuser.getPassword()); 
			}
			tx.commit();
		} catch (HibernateException e) {
			if (tx!=null)
				tx.rollback();
			e.printStackTrace(); 
		} finally {
			session.close(); 
		}
	}

	/* Method to UPDATE salary for an adminuser */
	public void updateAdminuser(Integer AdminuserID, String password) {
		Session session = factory.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Adminuser adminuser =	(Adminuser)session.get(Adminuser.class, AdminuserID); 
			adminuser.setPassword(password);
			session.update(adminuser); 
			tx.commit();
		} catch (HibernateException e) {
			if (tx!=null)
				tx.rollback();
			e.printStackTrace(); 
		} finally {
			session.close(); 
		}
	}

	/* Method to DELETE an adminuser from the records */
	public void deleteAdminuser(Integer AdminuserID){
		Session session = factory.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Adminuser adminuser = (Adminuser)session.get(Adminuser.class, AdminuserID); 
			session.delete(adminuser); 
			tx.commit();
		} catch (HibernateException e) {
			if (tx!=null)
				tx.rollback();
			e.printStackTrace(); 
		} finally {
			session.close(); 
		}
	}
}

