/*
	Project : MARCEL_CRUD_2
	File : CollectionAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;



import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Collection;
import org.dao.CollectionDAO;
import org.dao.CollectionDAOImpl;

public class CollectionAction extends ActionSupport implements ModelDriven<Collection> {

	private static final long serialVersionUID = 1L;

	private Collection collection = new Collection();
	private List<Collection> collectionList = new ArrayList<Collection>();
	private CollectionDAO collectionDAO = new CollectionDAOImpl();

	@Override
	public Collection getModel() {
		return collection;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update collection.
	 * @return String
	 */
	public String saveOrUpdateCollection() {	
		System.out.println("");
		System.out.println("CollectionAction.java");
		System.out.println("method : saveOrUpdateCollection()");

		System.out.println("colid " + collection.getColid());
		System.out.println("coltitle " + collection.getColtitle()); 
		System.out.println("date " + collection.getDate());
		System.out.println("format " + collection.getFormat());
		System.out.println("isbn1 " + collection.getIsbn1());

		collectionDAO.saveOrUpdateCollection(collection);
		return SUCCESS;
	}

	/**
	 * To delete an collection.
	 * @return String
	 */
	public String deleteCollection() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		collectionDAO.deleteCollection(Long.parseLong( request.getParameter("colid")));
		return SUCCESS;
	}

	/**
	 * To list all collection.
	 * @return String
	 */
	public String listCollection() {
		System.out.println("");
		System.out.println("CollectionAction.java");
		System.out.println("method : listCollection()");
		collectionList = collectionDAO.listCollection();
		System.out.println("");
		System.out.println("collectionList.size() : ---------> " + collectionList.size());
		return SUCCESS;
	}

	/**
	 * To read one collecions.
	 * @return String
	 */
	public String readCollection() {
		System.out.println("");
		System.out.println("CollectionAction.java");
		System.out.println("method : readCollection()");

		System.out.println("colid " + collection.getColid());
		System.out.println("coltitle " + collection.getColtitle()); 
		System.out.println("date " + collection.getDate());
		System.out.println("format " + collection.getFormat());
		System.out.println("isbn1 " + collection.getIsbn1());

		try {
			this.collectionList = collectionDAO.readCollection(collection);
			System.out.println("this.adminsList.size() : " + this.collectionList.size());
			//if (adminsList.size() > 0) {
			//	return SUCCESS;
			//}
			Collection itCollection = null;
			Iterator<Collection> it = this.collectionList.iterator();
			while (it.hasNext()) {
				itCollection = it.next();
				if ( itCollection.getColid() == collection.getColid() &&
					 itCollection.getColtitle().equals(collection.getColtitle() ) ){
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itCollection.getColid());
					System.out.println("******* TROBAT ******* " + itCollection.getColtitle());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single collection by Name.
	 * @return String
	 */
	public String editCollection() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		collection = collectionDAO.listCollectionById(Long.parseLong( request.getParameter("colid")));
		return SUCCESS;
	}

	public Collection getCollection() {
		return collection;
	}

	public void setCollection(Collection collection) {
		this.collection = collection;
	}

	public List<Collection> getCollectionList() {
		return collectionList;
	}

	public void setCollectionList(List<Collection> collectionList) {
		this.collectionList = collectionList;
	}

}

