/*
	Project : MARCEL_CRUD_2
	File : CollectitemAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;




import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Collectitem;
import org.dao.CollectitemDAO;
import org.dao.CollectitemDAOImpl;

public class CollectitemAction extends ActionSupport implements ModelDriven<Collectitem> {

	private static final long serialVersionUID = 1L;

	private Collectitem collectitem = new Collectitem();
	private List<Collectitem> collectitemList = new ArrayList<Collectitem>();
	private CollectitemDAO collectitemDAO = new CollectitemDAOImpl();

	@Override
	public Collectitem getModel() {
		return collectitem;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update collectitem.
	 * @return String
	 */
	public String saveOrUpdateCollectitem() {	
		System.out.println("");
		System.out.println("CollectitemAction.java");
		System.out.println("method : saveOrUpdateCollectitem()");

		System.out.println("seqid " + collectitem.getSeqid());
		System.out.println("colitid " + collectitem.getCollection().getColid()); 
		System.out.println("colitindex " + collectitem.getColitindex());
		System.out.println("colitpubid " + collectitem.getPublication().getPubid());

		collectitemDAO.saveOrUpdateCollectitem(collectitem);
		return SUCCESS;
	}

	/**
	 * To delete an collectitem.
	 * @return String
	 */
	public String deleteCollectitem() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		collectitemDAO.deleteCollectitem(Long.parseLong( request.getParameter("seqid")));
		return SUCCESS;
	}

	/**
	 * To list all collectitem.
	 * @return String
	 */
	public String listCollectitem() {
		System.out.println("");
		System.out.println("CollectitemAction.java");
		System.out.println("method : listCollectitem()");
		collectitemList = collectitemDAO.listCollectitem();
		System.out.println("");
		System.out.println("collectitemList.size() : ---------> " + collectitemList.size());
		return SUCCESS;
	}

	/**
	 * To read one collectitems.
	 * @return String
	 */
	public String readCollectitem() {
		System.out.println("");
		System.out.println("CollectitemAction.java");
		System.out.println("method : readCollectitem()");
		System.out.println("seqid " + collectitem.getSeqid());
		System.out.println("colitid " + collectitem.getCollection().getColid()); 
		System.out.println("colitindex " + collectitem.getColitindex());
		System.out.println("colitpubid " + collectitem.getPublication().getPubid());

		try {
			this.collectitemList = collectitemDAO.readCollectitem(collectitem);
			System.out.println("this.collectitemList.size() : " + this.collectitemList.size());
			//if (collectitemList.size() > 0) {
			//	return SUCCESS;
			//}
			Collectitem itCollectitem = null;
			Iterator<Collectitem> it = this.collectitemList.iterator();
			while (it.hasNext()) {
				itCollectitem = it.next();
				if ( itCollectitem.getSeqid() == collectitem.getSeqid() ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itCollectitem.getSeqid());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single collectitem by Name.
	 * @return String
	 */
	public String editCollectitem() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		collectitem = collectitemDAO.listCollectitemById(Long.parseLong( request.getParameter("seqid")));
		return SUCCESS;
	}

	public Collectitem getCollectitem() {
		return collectitem;
	}

	public void setCollectitem(Collectitem collectitem) {
		this.collectitem = collectitem;
	}

	public List<Collectitem> getCollectitemList() {
		return collectitemList;
	}

	public void setCollectitemList(List<Collectitem> collectitemList) {
		this.collectitemList = collectitemList;
	}

}

