/*
	Project : MARCEL_CRUD_2
	File : CustomerAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Customer;
import org.dao.CustomerDAO;
import org.dao.CustomerDAOImpl;

public class CustomerAction extends ActionSupport implements ModelDriven<Customer> {

	private static final long serialVersionUID = 1L;

	private Customer customer = new Customer();
	private List<Customer> customerList = new ArrayList<Customer>();
	private CustomerDAO customerDAO = new CustomerDAOImpl();

	@Override
	public Customer getModel() {
		return customer;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update customer.
	 * @return String
	 */
	public String saveOrUpdateCustomer() {	
		System.out.println("");
		System.out.println("CustomerAction.java");
		System.out.println("method : saveOrUpdateCustomer()");
		customerDAO.saveOrUpdateCustomer(customer);
		return SUCCESS;
	}

	/**
	 * To delete an customer.
	 * @return String
	 */
	public String deleteCustomer() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		customerDAO.deleteCustomer(Long.parseLong( request.getParameter("custid")));
		return SUCCESS;
	}

	/**
	 * To list all customer.
	 * @return String
	 */
	public String listCustomer() {
		System.out.println("");
		System.out.println("CustomerAction.java");
		System.out.println("method : listCustomer()");
		customerList = customerDAO.listCustomer();
		return SUCCESS;
	}

	/**
	 * To read one customer.
	 * @return String
	 */
	public String readCustomer() {
		System.out.println("");
		System.out.println("CustomerAction.java");
		System.out.println("method : readCustomer()");
		System.out.println("customer id : " + customer.getCustid());
		System.out.println("customer user id : " + customer.getUser().getUserid());
		System.out.println("customer notes : " + customer.getNotes());

		try {
			this.customerList = customerDAO.readCustomer(customer);
			System.out.println("this.customerList.size() : " + this.customerList.size());
			//if (customerList.size() > 0) {
			//	return SUCCESS;
			//}
			Customer itCustomer = null;
			Iterator<Customer> it = this.customerList.iterator();
			while (it.hasNext()) {
				itCustomer = it.next();
				if ( itCustomer.getCustid().equals(customer.getCustid() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itCustomer.getCustid());
					System.out.println("******* TROBAT ******* " + itCustomer.getUser().getUserid());
					System.out.println("******* TROBAT ******* " + itCustomer.getNotes());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single customer by Name.
	 * @return String
	 */
	public String editCustomer() {
		System.out.println("");
		System.out.println("CustomerAction.java");
		System.out.println("method : editCustomer()");
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		customer = customerDAO.listCustomerById(Long.parseLong( request.getParameter("custid")));
		System.out.println("customer id : " + request.getParameter("custid"));
		return SUCCESS;
	}

	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	public List<Customer> getCustomerList() {
		return customerList;
	}

	public void setCustomerList(List<Customer> customerList) {
		this.customerList = customerList;
	}

}

