/*
	Project : MARCEL_CRUD_2
	File : OrderitemsAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Customer;
import org.model.Orderitems;
import org.dao.OrderitemsDAO;
import org.dao.OrderitemsDAOImpl;

public class OrderitemsAction extends ActionSupport implements ModelDriven<Orderitems> {

	private static final long serialVersionUID = 1L;

	private Orderitems orderitems = new Orderitems();
	private List<Orderitems> orderitemsList = new ArrayList<Orderitems>();
	private OrderitemsDAO orderitemsDAO = new OrderitemsDAOImpl();

	@Override
	public Orderitems getModel() {
		return orderitems;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update orderitems.
	 * @return String
	 */
	public String saveOrUpdateOrderitems() {	
		System.out.println("");
		System.out.println("OrderitemsAction.java");
		System.out.println("method : saveOrUpdateOrderitems()");
		orderitemsDAO.saveOrUpdateOrderitems(orderitems);
		return SUCCESS;
	}

	/**
	 * To delete an orderitems.
	 * @return String
	 */
	public String deleteOrderitems() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		orderitemsDAO.deleteOrderitems(Long.parseLong( request.getParameter("seqid")));
		return SUCCESS;
	}

	/**
	 * To list all orderitems.
	 * @return String
	 */
	public String listOrderitems() {
		System.out.println("");
		System.out.println("OrderitemsAction.java");
		System.out.println("method : listOrderitems()");
		orderitemsList = orderitemsDAO.listOrderitems();
		System.out.println("orderitemsList.size() " + orderitemsList.size());
		return SUCCESS;
	}

	/**
	 * To read one orderitems.
	 * @return String
	 */
	public String readOrderitems() {
		System.out.println("");
		System.out.println("OrderitemsAction.java");
		System.out.println("method : readOrderitems()");

		System.out.println("orderitems id : " + orderitems.getSeqid());
		System.out.println("orderitems orderi_orderid : " + orderitems.getOrders());
		System.out.println("orderitems orderi_line : " + orderitems.getOrderiLine());
		System.out.println("orderitems prodorcol : " + orderitems.getProdorcol());
		System.out.println("orderitems itemid : " + orderitems.getItemid());
		System.out.println("orderitems name : " + orderitems.getName());
		System.out.println("orderitems price : " + orderitems.getPrice());

		try {
			this.orderitemsList = orderitemsDAO.readOrderitems(orderitems);
			System.out.println("this.orderitemsList.size() : " + this.orderitemsList.size());
			//if (orderitemsList.size() > 0) {
			//	return SUCCESS;
			//}
			Orderitems itOrderitems = null;
			Iterator<Orderitems> it = this.orderitemsList.iterator();
			while (it.hasNext()) {
				itOrderitems = it.next();
				if ( itOrderitems.getSeqid() == orderitems.getSeqid() ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itOrderitems.getSeqid());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single orderitems by Name.
	 * @return String
	 */
	public String editOrderitems() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		orderitems = orderitemsDAO.listOrderitemsById(Long.parseLong( request.getParameter("seqid")));
		return SUCCESS;
	}

	public Orderitems getOrderitems() {
		return orderitems;
	}

	public void setOrderitems(Orderitems orderitems) {
		this.orderitems = orderitems;
	}

	public List<Orderitems> getOrderitemsList() {
		return orderitemsList;
	}

	public void setOrderitemsList(List<Orderitems> orderitemsList) {
		this.orderitemsList = orderitemsList;
	}

}

