/*
	Project : MARCEL_CRUD_2
	File : OrdersAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Customer;
import org.model.Orderitems;
import org.model.Orders;
import org.dao.OrdersDAO;
import org.dao.OrdersDAOImpl;

public class OrdersAction extends ActionSupport implements ModelDriven<Orders> {

	private static final long serialVersionUID = 1L;

	private Orders orders = new Orders();
	private List<Orders> ordersList = new ArrayList<Orders>();
	private OrdersDAO ordersDAO = new OrdersDAOImpl();

	@Override
	public Orders getModel() {
		return orders;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update orders.
	 * @return String
	 */
	public String saveOrUpdateOrders() {	
		System.out.println("");
		System.out.println("OrdersAction.java");
		System.out.println("method : saveOrUpdateOrders()");
		ordersDAO.saveOrUpdateOrders(orders);
		return SUCCESS;
	}

	/**
	 * To delete an orders.
	 * @return String
	 */
	public String deleteOrders() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		ordersDAO.deleteOrders(Long.parseLong( request.getParameter("orderid")));
		return SUCCESS;
	}

	/**
	 * To list all orders.
	 * @return String
	 */
	public String listOrders() {
		System.out.println("");
		System.out.println("OrdersAction.java");
		System.out.println("method : listOrders()");
		ordersList = ordersDAO.listOrders();
		System.out.println("ordersList.size() " + ordersList.size());
		return SUCCESS;
	}

	/**
	 * To read one orders.
	 * @return String
	 */
	public String readOrders() {
		System.out.println("");
		System.out.println("OrdersAction.java");
		System.out.println("method : readOrders()");

		System.out.println("orders id : " + orders.getOrderid());
		System.out.println("orders customer : " + orders.getCustomer().getCustid());
		System.out.println("orders number : " + orders.getOrdernumber());
		System.out.println("orders year : " + orders.getOrderyear());
		System.out.println("orders date : " + orders.getOrderdate());

		try {
			this.ordersList = ordersDAO.readOrders(orders);
			System.out.println("this.ordersList.size() : " + this.ordersList.size());
			//if (ordersList.size() > 0) {
			//	return SUCCESS;
			//}
			Orders itOrders = null;
			Iterator<Orders> it = this.ordersList.iterator();
			while (it.hasNext()) {
				itOrders = it.next();
				if ( itOrders.getOrderid().equals(orders.getOrderid() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itOrders.getOrderid());
					System.out.println("******* TROBAT ******* " + itOrders.getCustomer().getCustid());
					System.out.println("******* TROBAT ******* " + itOrders.getOrdernumber());
					System.out.println("******* TROBAT ******* " + itOrders.getOrderyear());
					System.out.println("******* TROBAT ******* " + itOrders.getOrderdate());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single orders by Name.
	 * @return String
	 */
	public String editOrders() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		orders = ordersDAO.listOrdersById(Long.parseLong( request.getParameter("orderid")));
		return SUCCESS;
	}

	public Orders getOrders() {
		return orders;
	}

	public void setOrders(Orders orders) {
		this.orders = orders;
	}

	public List<Orders> getOrdersList() {
		return ordersList;
	}

	public void setOrdersList(List<Orders> ordersList) {
		this.ordersList = ordersList;
	}

}

