/*
	Project : MARCEL_CRUD_2
	File : PublicationAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Publication;
import org.dao.PublicationDAO;
import org.dao.PublicationDAOImpl;

public class PublicationAction extends ActionSupport implements ModelDriven<Publication> {

	private static final long serialVersionUID = 1L;

	private Publication publication = new Publication();
	private List<Publication> publicationList = new ArrayList<Publication>();
	private PublicationDAO publicationDAO = new PublicationDAOImpl();

	@Override
	public Publication getModel() {
		return publication;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update publication.
	 * @return String
	 */
	public String saveOrUpdatePublication() {	
		System.out.println("");
		System.out.println("PublicationAction.java");
		System.out.println("method : saveOrUpdatePublication()");
		publicationDAO.saveOrUpdatePublication(publication);
		return SUCCESS;
	}

	/**
	 * To delete an publication.
	 * @return String
	 */
	public String deletePublication() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		publicationDAO.deletePublication(Long.parseLong( request.getParameter("pubid")));
		return SUCCESS;
	}

	/**
	 * To list all publication.
	 * @return String
	 */
	public String listPublication() {
		System.out.println("");
		System.out.println("PublicationAction.java");
		System.out.println("method : listPublication()");
		publicationList = publicationDAO.listPublication();
		return SUCCESS;
	}

	/**
	 * To read one publication.
	 * @return String
	 */
	public String readPublication() {
		System.out.println("");
		System.out.println("PublicationAction.java");
		System.out.println("method : readPublication()");
		System.out.println("publication id : " + publication.getPubid());
		System.out.println("publication title : " + publication.getTitle());
		System.out.println("publication author : " + publication.getAuthor());

		try {
			this.publicationList = publicationDAO.readPublication(publication);
			System.out.println("this.publicationList.size() : " + this.publicationList.size());
			//if (publicationList.size() > 0) {
			//	return SUCCESS;
			//}
			Publication itPublication = null;
			Iterator<Publication> it = this.publicationList.iterator();
			while (it.hasNext()) {
				itPublication = it.next();
				if ( itPublication.getPubid().equals(publication.getPubid() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itPublication.getPubid());
					System.out.println("******* TROBAT ******* " + itPublication.getTitle());
					System.out.println("******* TROBAT ******* " + itPublication.getAuthor());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single publication by Name.
	 * @return String
	 */
	public String editPublication() {
		System.out.println("");
		System.out.println("PublicationAction.java");
		System.out.println("method : editPublication()");
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		publication = publicationDAO.listPublicationById(Long.parseLong( request.getParameter("pubid")));
		System.out.println("publication id : " + request.getParameter("pubid"));
		return SUCCESS;
	}

	public Publication getPublication() {
		return publication;
	}

	public void setPublication(Publication publication) {
		this.publication = publication;
	}

	public List<Publication> getPublicationList() {
		return publicationList;
	}

	public void setPublicationList(List<Publication> publicationList) {
		this.publicationList = publicationList;
	}

}

