/*
	Project : MARCEL_CRUD_2
	File : PublitemeAction.java
	Author : MSA
	Date : 14/12/2013
	Source : http://www.dzone.com/tutorials/java/struts-2/struts-2-example/struts-2-crud-example-1.html
			 http://www.mkyong.com/struts2/how-to-get-the-httpservletrequest-in-struts-2/
			 ----> import org.apache.struts2.interceptor.ServletRequestAware;

	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Publiteme;
import org.dao.PublitemeDAO;
import org.dao.PublitemeDAOImpl;

public class PublitemeAction extends ActionSupport implements ModelDriven<Publiteme> {

	private static final long serialVersionUID = 1L;

	private Publiteme publiteme = new Publiteme();
	private List<Publiteme> publitemeList = new ArrayList<Publiteme>();
	private PublitemeDAO publitemeDAO = new PublitemeDAOImpl();

	@Override
	public Publiteme getModel() {
		return publiteme;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update publiteme.
	 * @return String
	 */
	public String saveOrUpdatePubliteme() {	
		System.out.println("");
		System.out.println("PublitemeAction.java");
		System.out.println("method : saveOrUpdatePubliteme()");
		publitemeDAO.saveOrUpdatePubliteme(publiteme);
		return SUCCESS;
	}

	/**
	 * To delete an publiteme.
	 * @return String
	 */
	public String deletePubliteme() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		publitemeDAO.deletePubliteme(Long.parseLong( request.getParameter("id")));
		return SUCCESS;
	}

	/**
	 * To list all publiteme.
	 * @return String
	 */
	public String listPubliteme() {
		System.out.println("");
		System.out.println("PublitemeAction.java");
		System.out.println("method : listPubliteme()");
		publitemeList = publitemeDAO.listPubliteme();
		System.out.println("");
		System.out.println("publitemeList.size() : " + publitemeList.size());
		System.out.println("exit method : listPubliteme()");
		System.out.println("");
		return SUCCESS;
	}

	/**
	 * To read one publitemes.
	 * @return String
	 */
	public String readPubliteme() {
		System.out.println("");
		System.out.println("PublitemeAction.java");
		System.out.println("method : readPubliteme()");
		System.out.println("publiteme id : " + publiteme.getId());
		System.out.println("publiteme pubid : " + publiteme.getPublication().getPubid());
		System.out.println("publiteme temeid : " + publiteme.getTeme().getId());

		try {
			this.publitemeList = publitemeDAO.readPubliteme(publiteme);
			System.out.println("this.publitemeList.size() : " + this.publitemeList.size());
			//if (publitemeList.size() > 0) {
			//	return SUCCESS;
			//}
			Publiteme itPubliteme = null;
			Iterator<Publiteme> it = this.publitemeList.iterator();
			while (it.hasNext()) {
				itPubliteme = it.next();
				System.out.println("publiteme id : " + publiteme.getId());
				System.out.println("publiteme pubid : " + publiteme.getPublication().getPubid());
				System.out.println("publiteme temeid : " + publiteme.getTeme().getId());
				if ( itPubliteme.getId().equals(publiteme.getId() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itPubliteme.getId());
					System.out.println("******* TROBAT ******* " + itPubliteme.getPublication().getPubid());
					System.out.println("******* TROBAT ******* " + itPubliteme.getTeme().getId());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single publiteme by Name.
	 * @return String
	 */
	public String editPubliteme() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		publiteme = publitemeDAO.listPublitemeById(Long.parseLong( request.getParameter("id")));
		return SUCCESS;
	}

	public Publiteme getPubliteme() {
		return publiteme;
	}

	public void setPubliteme(Publiteme publiteme) {
		this.publiteme = publiteme;
	}

	public List<Publiteme> getPublitemeList() {
		return publitemeList;
	}

	public void setPublitemeList(List<Publiteme> publitemeList) {
		this.publitemeList = publitemeList;
	}

}

