/*
	Project : MARCEL_CRUD_2
	File : TemeAction.java
	Author : MSA
	Date : 10/01/2014
	Source : 
	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.Teme;
import org.dao.TemeDAO;
import org.dao.TemeDAOImpl;

public class TemeAction extends ActionSupport implements ModelDriven<Teme> {

	private static final long serialVersionUID = 1L;

	private Teme teme = new Teme();
	private List<Teme> temeList = new ArrayList<Teme>();
	private TemeDAO temeDAO = new TemeDAOImpl();

	@Override
	public Teme getModel() {
		return teme;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update teme.
	 * @return String
	 */
	public String saveOrUpdateTeme() {	
		System.out.println("");
		System.out.println("TemeAction.java");
		System.out.println("method : saveOrUpdateTeme()");
		temeDAO.saveOrUpdateTeme(teme);
		return SUCCESS;
	}

	/**
	 * To delete a teme.
	 * @return String
	 */
	public String deleteTeme() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		temeDAO.deleteTeme(Long.parseLong( request.getParameter("id")));
		return SUCCESS;
	}

	/**
	 * To list all teme.
	 * @return String
	 */
	public String listTeme() {
		System.out.println("");
		System.out.println("TemeAction.java");
		System.out.println("method : listTeme()");
		System.out.println("");
		System.out.println("");
		temeList = temeDAO.listTeme();
		if ( temeList == null ) {
			System.out.println("");
			System.out.println("temeList null");
			System.out.println("");
			System.out.println("");
		}
		System.out.println("temeList.size() : " + temeList.size());
		System.out.println("");
		System.out.println("end of method : listTeme()");
		System.out.println("");
		return SUCCESS;
	}

	/**
	 * To read one temes.
	 * @return String
	 */
	public String readTeme() {
		System.out.println("");
		System.out.println("TemeAction.java");
		System.out.println("method : readTeme()");
		System.out.println("id : " + teme.getId());
		System.out.println("code : " + teme.getCode());
		System.out.println("password : " + teme.getDescription());

		try {
			this.temeList = temeDAO.readTeme(teme);
			System.out.println("this.temeList.size() : " + this.temeList.size());
			//if (temeList.size() > 0) {
			//	return SUCCESS;
			//}
			Teme itTeme = null;
			Iterator<Teme> it = this.temeList.iterator();
			while (it.hasNext()) {
				itTeme = it.next();
				if ( itTeme.getId().equals(teme.getId() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itTeme.getId());
					System.out.println("******* TROBAT ******* " + itTeme.getCode());
					System.out.println("******* TROBAT ******* " + itTeme.getDescription());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single teme by Name.
	 * @return String
	 */
	public String editTeme() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		teme = temeDAO.listTemeById(Long.parseLong( request.getParameter("id")));
		return SUCCESS;
	}

	public Teme getTeme() {
		return teme;
	}

	public void setTeme(Teme teme) {
		this.teme = teme;
	}

	public List<Teme> getTemeList() {
		return temeList;
	}

	public void setTemeList(List<Teme> temeList) {
		this.temeList = temeList;
	}

}
