/*
	Project : MARCEL_CRUD_2
	File : UserAction.java
	Author : MSA
	Date : 14/12/2013
	Source : 
	Notes : 
*/
package org.action;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

//import org.apache.struts2.interceptor.ServletRequestAware;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

import org.model.User;
import org.dao.UserDAO;
import org.dao.UserDAOImpl;

public class UserAction extends ActionSupport implements ModelDriven<User> {

	private static final long serialVersionUID = 1L;

	private User user = new User();
	private List<User> userList = new ArrayList<User>();
	private UserDAO userDAO = new UserDAOImpl();

	@Override
	public User getModel() {
		return user;
	}

	public String execute() {
		return SUCCESS;
	}

	/**
	 * To save or update user.
	 * @return String
	 */
	public String saveOrUpdateUser() {	
		System.out.println("");
		System.out.println("UserAction.java");
		System.out.println("method : saveOrUpdateUser()");
		userDAO.saveOrUpdateUser(user);
		return SUCCESS;
	}

	/**
	 * To delete an user.
	 * @return String
	 */
	public String deleteUser() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		userDAO.deleteUser(Long.parseLong( request.getParameter("userid")));
		return SUCCESS;
	}

	/**
	 * To list all user.
	 * @return String
	 */
	public String listUser() {
		System.out.println("");
		System.out.println("UserAction.java");
		System.out.println("method : listUser()");
		userList = userDAO.listUser();
		return SUCCESS;
	}

	/**
	 * To read one user.
	 * @return String
	 */
	public String readUser() {
		System.out.println("");
		System.out.println("UserAction.java");
		System.out.println("method : readUser()");
		System.out.println("userid : " + user.getUserid());
		System.out.println("usercode : " + user.getUsercode());
		System.out.println("password : " + user.getPassword());

		try {
			this.userList = userDAO.readUser(user);
			System.out.println("this.userList.size() : " + this.userList.size());
			//if (userList.size() > 0) {
			//	return SUCCESS;
			//}
			User itUser = null;
			Iterator<User> it = this.userList.iterator();
			while (it.hasNext()) {
				itUser = it.next();
				if ( itUser.getUserid().equals(user.getUserid() ) ) {
					System.out.println("");
					System.out.println("******* TROBAT ******* " + itUser.getUserid());
					System.out.println("******* TROBAT ******* " + itUser.getUsercode());
					System.out.println("******* TROBAT ******* " + itUser.getPassword());
					System.out.println("");
					return SUCCESS;
				}
				System.out.println("while");
			}
			System.out.println("");
			System.out.println("NO TROBAT");
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return ERROR;
	}

	/**
	 * To list a single user by Name.
	 * @return String
	 */
	public String editUser() {
		HttpServletRequest request =
			(HttpServletRequest) ActionContext.getContext().get( ServletActionContext.HTTP_REQUEST);
		user = userDAO.listUserById(Long.parseLong( request.getParameter("userid")));
		return SUCCESS;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public List<User> getUserList() {
		return userList;
	}

	public void setUserList(List<User> userList) {
		this.userList = userList;
	}

}

