/*
	File : AdminuserDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;
//import java.util.Iterator;

import org.model.Adminuser;
import org.dao.AdminuserDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class AdminuserDAOImpl implements AdminuserDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an adminuser, by adminid.
	 */
	@Override
	public void saveOrUpdateAdminuser(Adminuser adminuser) {
		
		if (adminuser == null) {
			System.out.println("adminuser nullid");
		} else {
			System.out.println("adminid " + adminuser.getAdminid());	//	id	int(11) NOT NULL AUTO_INCREMENT,
			System.out.println("admincode " + adminuser.getAdmincode());	//	name	varchar(40) DEFAULT NULL, 
			System.out.println("password " + adminuser.getPassword());	//	password	varchar(40) DEFAULT NULL,
		}

		try {
			session.saveOrUpdate(adminuser);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an adminuser, by adminid.
	 */
	@Override
	public void deleteAdminuser(Long adminid) {
		try {
			Adminuser adminuser = (Adminuser) session.get(Adminuser.class, adminid);
			session.delete(adminuser);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the adminuser.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Adminuser> listAdminuser() {
		System.out.println("");
		System.out.println("AdminuserDAOImpl.java");
		System.out.println("method : listAdminuser");
		List<Adminuser> listadminuser = null;
		try {
			listadminuser = session.createQuery("from Adminuser").list();
			System.out.println("");
			System.out.println("listadminuser.size() : " + listadminuser.size());
		} catch (Exception e) {
			System.out.println("ERROR in listAdminuser");
			e.printStackTrace();
		}
		return listadminuser;
	}

	/**
	 * Used to list all the admins.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Adminuser> readAdminuser(Adminuser adminuser) {
		List<Adminuser> listAdminuser = null;
		System.out.println("");
		System.out.println("AdminuserDAOImpl.java");
		System.out.println("method : readAdminuser");
		System.out.println("admins.getAdminid() : " + adminuser.getAdminid());
		System.out.println("admins.getAdminCode() : " + adminuser.getAdmincode());
		System.out.println("admins.getPassword() : " + adminuser.getPassword());

		try {
			String hql = "from Adminuser A where A.admincode = :adminusercode AND A.password = :adminuserpassword";
			Query query = session.createQuery(hql);
			query.setParameter("adminusercode", adminuser.getAdmincode());
			query.setParameter("adminuserpassword", adminuser.getPassword());
			listAdminuser = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listAdminuser;
	}

	/**
	 * Used to list a single adminuser by Id.
	 */
	@Override
	public Adminuser listAdminuserById(Long adminid) {
		Adminuser adminuser = null;
		try {
			adminuser = (Adminuser) session.get(Adminuser.class, adminid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return adminuser;
	}

}

