/*
	File : CollectionDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Collection;
import org.dao.CollectionDAO;
//import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class CollectionDAOImpl implements CollectionDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an collection, by colid.
	 */
	@Override
	public void saveOrUpdateCollection(Collection collection) {
		
		if (collection == null) {
			System.out.println("collection nullid");
		} else {
			System.out.println("colid " + collection.getColid());
			System.out.println("coltitle " + collection.getColtitle()); 
			System.out.println("date " + collection.getDate());
			System.out.println("format " + collection.getFormat());
			System.out.println("isbn1 " + collection.getIsbn1());
		}

		try {
			session.saveOrUpdate(collection);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an collection, by colid.
	 */
	@Override
	public void deleteCollection(Long colid) {
		try {
			Collection collection = (Collection) session.get(Collection.class, colid);
			session.delete(collection);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the collection.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Collection> listCollection() {
		System.out.println("");
		System.out.println("CollectionDAOImpl.java");
		System.out.println("method : listCollection");
		List<Collection> listcollection = null;
		try {
			listcollection = session.createQuery("from Collection").list();
			System.out.println("");
			System.out.println("listcollection.size() : " + listcollection.size());
		} catch (Exception e) {
			System.out.println("ERROR in listCollection");
			e.printStackTrace();
		}
		return listcollection;
	}

	/**
	 * Used to list all the collection.
	 */
	@Override
	public List<Collection> readCollection(Collection collection) {
		List<Collection> listCollection = null;
//		System.out.println("");
//		System.out.println("CollectionDAOImpl.java");
//		System.out.println("method : readCollection");
//		System.out.println("colid " + collection.getColid());
//		System.out.println("coltitle " + collection.getColtitle()); 
//		System.out.println("date " + collection.getDate());
//		System.out.println("format " + collection.getFormat());
//		System.out.println("isbn1 " + collection.getIsbn1());
//
//		try {
//			String hql = "from Collection A where A.admincode = :collectioncode AND A.password = :collectionpassword";
//			Query query = session.createQuery(hql);
//			query.setParameter("collectioncode", collection.getAdmincode());
//			query.setParameter("collectionpassword", collection.getPassword());
//			listCollection = query.list();
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
		return listCollection;
	}

	/**
	 * Used to list a single collection by Id.
	 */
	@Override
	public Collection listCollectionById(Long colid) {
		Collection collection = null;
		try {
			collection = (Collection) session.get(Collection.class, colid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return collection;
	}

}


