/*
	File : CollectitemDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Collectitem;
import org.dao.CollectitemDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class CollectitemDAOImpl implements CollectitemDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an collectitem, by seqid.
	 */
	@Override
	public void saveOrUpdateCollectitem(Collectitem collectitem) {
		
		if (collectitem == null) {
			System.out.println("collectitem nullid");
		} else {
			System.out.println("seqid " + collectitem.getSeqid());
			System.out.println("colitid " + collectitem.getCollection().getColid()); 
			System.out.println("colitindex " + collectitem.getColitindex());
			System.out.println("colitpubid " + collectitem.getPublication().getPubid());
		}

		try {
			session.saveOrUpdate(collectitem);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an collectitem, by seqid.
	 */
	@Override
	public void deleteCollectitem(Long seqid) {
		try {
			Collectitem collectitem = (Collectitem) session.get(Collectitem.class, seqid);
			session.delete(collectitem);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the collectitem.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Collectitem> listCollectitem() {
		System.out.println("");
		System.out.println("CollectitemDAOImpl.java");
		System.out.println("method : listCollectitem");
		List<Collectitem> listcollectitem = null;
		try {
			listcollectitem = session.createQuery("from Collectitem").list();
			System.out.println("");
			System.out.println("listcollectitem.size() : " + listcollectitem.size());
		} catch (Exception e) {
			System.out.println("ERROR in listCollectitem");
			e.printStackTrace();
		}
		return listcollectitem;
	}

	/**
	 * Used to list all the seqid.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Collectitem> readCollectitem(Collectitem collectitem) {
		List<Collectitem> listCollectitem = null;
		System.out.println("");
		System.out.println("CollectitemDAOImpl.java");
		System.out.println("method : readCollectitem");
		System.out.println("seqid " + collectitem.getSeqid());
		System.out.println("colitid " + collectitem.getCollection().getColid()); 
		System.out.println("colitindex " + collectitem.getColitindex());
		System.out.println("colitpubid " + collectitem.getPublication().getPubid());

		try {
			String hql = "from Collectitem C where C.seqid = :collectitemcode";
			Query query = session.createQuery(hql);
			query.setParameter("collectitemcode", collectitem.getSeqid());
			listCollectitem = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listCollectitem;
	}

	/**
	 * Used to list a single collectitem by Id.
	 */
	@Override
	public Collectitem listCollectitemById(Long seqid) {
		Collectitem collectitem = null;
		try {
			collectitem = (Collectitem) session.get(Collectitem.class, seqid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return collectitem;
	}

}

