/*
	File : CustomerDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Customer;
import org.dao.CustomerDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class CustomerDAOImpl implements CustomerDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an customer, by customerid.
	 */
	@Override
	public void saveOrUpdateCustomer(Customer customer) {
		
		if (customer == null) {
			System.out.println("customer nullid");
		} else {
			System.out.println("customer id " + customer.getCustid());
			System.out.println("customer cardname " + customer.getCardname()); 
			System.out.println("customer cardcode " + customer.getCardcode());
			System.out.println("customer cardcode2 " + customer.getCarcode2());
			System.out.println("customer cardcode3 " + customer.getCarcode3());
			System.out.println("customer notes " + customer.getNotes());
		}

		try {
			session.saveOrUpdate(customer);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an customer, by customerid.
	 */
	@Override
	public void deleteCustomer(Long customerid) {
		try {
			Customer customer = (Customer) session.get(Customer.class, customerid);
			session.delete(customer);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the customer.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Customer> listCustomer() {
		System.out.println("");
		System.out.println("CustomerDAOImpl.java");
		System.out.println("listCustomer method"); 
		List<Customer> listcustomer = null;
		try {
			listcustomer = session.createQuery("from Customer").list();
			System.out.println("");
			System.out.println("listcustomer.size() " + listcustomer.size()); 
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listcustomer;
	}

	/**
	 * Used to list all the customers.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Customer> readCustomer(Customer customer) {
		List<Customer> listCustomer = null;
		System.out.println("");
		System.out.println("CustomerDAOImpl.java");
		System.out.println("method : readCustomer");
		System.out.println("customer id " + customer.getCustid());
		System.out.println("customer notes " + customer.getNotes()); 

		try {
			String hql = "from Customer C where C.custid = :custid";
			Query query = session.createQuery(hql);
			query.setParameter("custid", customer.getCustid());
			listCustomer = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listCustomer;
	}

	/**
	 * Used to list a single customer by Id.
	 */
	@Override
	public Customer listCustomerById(Long customerid) {
		Customer customer = null;
		try {
			customer = (Customer) session.get(Customer.class, customerid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return customer;
	}

}

