/*
	File : OrdersDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Orders;
import org.dao.OrdersDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class OrdersDAOImpl implements OrdersDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an order, by orderid.
	 */
	@Override
	public void saveOrUpdateOrders(Orders orders) {
		System.out.println("");
		System.out.println("OrdersDAOImpl.java");
		System.out.println("method : saveOrUpdateOrders");
		
		if (orders == null) {
			System.out.println("orders nullid");
		} else {
			System.out.println("orders id : " + orders.getOrderid());
			System.out.println("orders customer : " + orders.getCustomer().getCustid());
			System.out.println("orders number : " + orders.getOrdernumber());
			System.out.println("orders year : " + orders.getOrderyear());
			System.out.println("orders date : " + orders.getOrderdate());
		}

		try {
			session.saveOrUpdate(orders);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an orders, by orderid.
	 */
	@Override
	public void deleteOrders(Long orderid) {
		try {
			Orders orders = (Orders) session.get(Orders.class, orderid);
			session.delete(orders);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the orders.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Orders> listOrders() {
		System.out.println("");
		System.out.println("OrdersDAOImpl.java");
		System.out.println("method : listOrders");
		List<Orders> listorders = null;
		try {
			listorders = session.createQuery("from Orders").list();
			System.out.println("listorders.size() : " + listorders.size() );
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listorders;
	}

	/**
	 * Used to list all the orderss.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Orders> readOrders(Orders orders) {
		List<Orders> listOrders = null;
		System.out.println("");
		System.out.println("OrdersDAOImpl.java");
		System.out.println("method : readOrders");
		System.out.println("orders id : " + orders.getOrderid());
		System.out.println("orders customer : " + orders.getCustomer().getCustid());
		System.out.println("orders number : " + orders.getOrdernumber());
		System.out.println("orders year : " + orders.getOrderyear());
		System.out.println("orders date : " + orders.getOrderdate());

		try {
			String hql = "from Orders O where O.orderid = :orderid";
			Query query = session.createQuery(hql);
			query.setParameter("orderid", orders.getOrderid());
			listOrders = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listOrders;
	}

	/**
	 * Used to list a single orders by Id.
	 */
	@Override
	public Orders listOrdersById(Long orderid) {
		Orders orders = null;
		try {
			orders = (Orders) session.get(Orders.class, orderid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return orders;
	}

}

