/*
	File : PublicationDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Publication;
import org.dao.PublicationDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class PublicationDAOImpl implements PublicationDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an publication, by pubid.
	 */
	@Override
	public void saveOrUpdatePublication(Publication publication) {
		
		if (publication == null) {
			System.out.println("publication nullid");
		} else {
			System.out.println("publication id " + publication.getPubid());
			System.out.println("publication title " + publication.getTitle()); 
			System.out.println("publication author " + publication.getAuthor());
		}

		try {
			session.saveOrUpdate(publication);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an publication, by pubid.
	 */
	@Override
	public void deletePublication(Long pubid) {
		try {
			Publication publication = (Publication) session.get(Publication.class, pubid);
			session.delete(publication);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the publication.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Publication> listPublication() {
		List<Publication> listpublication = null;
		try {
			listpublication = session.createQuery("from Publication").list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listpublication;
	}

	/**
	 * Used to list all the publications.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Publication> readPublication(Publication publication) {
		List<Publication> listPublication = null;
		System.out.println("");
		System.out.println("PublicationDAOImpl.java");
		System.out.println("method : readPublication");
		System.out.println("publication id " + publication.getPubid());
		System.out.println("publication title " + publication.getTitle()); 
		System.out.println("publication author " + publication.getAuthor());

		try {
			String hql = "from Publication P where P.pubid = :pubid";
			Query query = session.createQuery(hql);
			query.setParameter("pubid", publication.getPubid());
			listPublication = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listPublication;
	}

	/**
	 * Used to list a single publication by Id.
	 */
	@Override
	public Publication listPublicationById(Long pubid) {
		Publication publication = null;
		try {
			publication = (Publication) session.get(Publication.class, pubid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return publication;
	}

}

