/*
	File : PublitemeDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Publiteme;
import org.dao.PublitemeDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class PublitemeDAOImpl implements PublitemeDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an publiteme, by publitemeid.
	 */
	@Override
	public void saveOrUpdatePubliteme(Publiteme publiteme) {
		System.out.println("");
		System.out.println("PublitemeDAOImpl.java");
		System.out.println("method : saveOrUpdatePubliteme");
		
		if (publiteme == null) {
			System.out.println("teme nullid");
		} else {
			System.out.println("publiteme id : " + publiteme.getId());
			System.out.println("publiteme publication : " + publiteme.getPublication().getPubid()); 
			System.out.println("publiteme teme : " + publiteme.getTeme().getId()); 
		}

		try {
			session.saveOrUpdate(publiteme);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an publiteme, by publitemeid.
	 */
	@Override
	public void deletePubliteme(Long publitemeid) {
		try {
			Publiteme publiteme = (Publiteme) session.get(Publiteme.class, publitemeid);
			session.delete(publiteme);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the publiteme.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Publiteme> listPubliteme() {
		List<Publiteme> listPubliteme = null;
		try {
			System.out.println("");
			System.out.println("PublitemeDAOImpl.java");
			System.out.println("method : listPubliteme");

			listPubliteme = session.createQuery("from Publiteme").list();

			System.out.println("listPubliteme.size() " + listPubliteme.size());
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listPubliteme;
	}

	/**
	 * Used to list all the admins.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Publiteme> readPubliteme(Publiteme publiteme) {
		List<Publiteme> listPubliteme = null;

		System.out.println("");
		System.out.println("PublitemeDAOImpl.java");
		System.out.println("method : readPubliteme");
		System.out.println("publiteme id : " + publiteme.getId());
		System.out.println("publiteme publication : " + publiteme.getPublication().getPubid()); 
		System.out.println("publiteme teme : " + publiteme.getTeme().getId()); 

		try {
			String hql = "from Publiteme P where P.publiteme_id = :publitemeid";
			Query query = session.createQuery(hql);
			query.setParameter("publitemeid", publiteme.getId());
			listPubliteme = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listPubliteme;
	}

	/**
	 * Used to list a single publiteme by Id.
	 */
	@Override
	public Publiteme listPublitemeById(Long publitemeid) {
		System.out.println("");
		System.out.println("PublitemeDAOImpl.java");
		System.out.println("method : listPublitemeById");
		Publiteme publiteme = null;
		try {
			publiteme = (Publiteme) session.get(Publiteme.class, publitemeid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return publiteme;
	}

}

