/*
	File : TemeDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.List;

import org.model.Teme;
import org.dao.TemeDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class TemeDAOImpl implements TemeDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an teme, by temeid.
	 */
	@Override
	public void saveOrUpdateTeme(Teme teme) {
		
		if (teme == null) {
			System.out.println("teme nullid");
		} else {
			System.out.println("teme id : " + teme.getId());
			System.out.println("teme code : " + teme.getCode()); 
			System.out.println("teme description : " + teme.getDescription());
		}

		try {
			session.saveOrUpdate(teme);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an teme, by temeid.
	 */
	@Override
	public void deleteTeme(Long temeid) {
		try {
			Teme teme = (Teme) session.get(Teme.class, temeid);
			session.delete(teme);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the teme.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Teme> listTeme() {
		List<Teme> listteme = null;
		try {
			System.out.println("");
			System.out.println("TemeDAOImpl.java");
			System.out.println("method : listTeme");

			listteme = session.createQuery("from Teme").list();

			System.out.println("listteme.size() " + listteme.size());
			System.out.println("");
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listteme;
	}

	/**
	 * Used to list all the admins.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<Teme> readTeme(Teme teme) {
		List<Teme> listTeme = null;

		System.out.println("");
		System.out.println("TemeDAOImpl.java");
		System.out.println("method : readTeme");
		System.out.println("teme id : " + teme.getId());
		System.out.println("teme code : " + teme.getCode()); 
		System.out.println("teme description : " + teme.getDescription());

		try {
			String hql = "from Teme T where T.temecode = :temecode";
			Query query = session.createQuery(hql);
			query.setParameter("temecode", teme.getCode());
			listTeme = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listTeme;
	}

	/**
	 * Used to list a single teme by Id.
	 */
	@Override
	public Teme listTemeById(Long temeid) {
		Teme teme = null;
		try {
			teme = (Teme) session.get(Teme.class, temeid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return teme;
	}

}

