/*
	File : UserDAOImpl.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.dao;

import java.util.Iterator;
import java.util.List;

import org.model.User;
import org.dao.UserDAO;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.googlecode.s2hibernate.struts2.plugin.annotations.SessionTarget;
import com.googlecode.s2hibernate.struts2.plugin.annotations.TransactionTarget;

public class UserDAOImpl implements UserDAO {

	@SessionTarget
	Session session;

	@TransactionTarget
	Transaction transaction;

	/**
	 * Used to save or update an user, by userid.
	 */
	@Override
	public void saveOrUpdateUser(User user) {
		
		if (user == null) {
			System.out.println("user nullid");
		} else {
			System.out.println("user id " + user.getUserid());	//	id	int(11) NOT NULL AUTO_INCREMENT,
			System.out.println("user code " + user.getUsercode());	//	name	varchar(40) DEFAULT NULL, 
			System.out.println("user password " + user.getPassword());	//	password	varchar(40) DEFAULT NULL,
		}

		try {
			session.saveOrUpdate(user);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		}
	}

	/**
	 * Used to delete an user, by userid.
	 */
	@Override
	public void deleteUser(Long userid) {
		try {
			User user = (User) session.get(User.class, userid);
			session.delete(user);
		} catch (Exception e) {
			transaction.rollback();
			e.printStackTrace();
		} 
	}

	/**
	 * Used to list all the user.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<User> listUser() {
		List<User> listuser = null;
		try {
			listuser = session.createQuery("from User").list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listuser;
	}

	/**
	 * Used to list all the users.
	 */
	@SuppressWarnings("unchecked")
	@Override
	public List<User> readUser(User user) {
		List<User> listUser = null;
		System.out.println("");
		System.out.println("UserDAOImpl.java");
		System.out.println("method : readUser");
		System.out.println("user id " + user.getUserid());
		System.out.println("user code " + user.getUsercode()); 
		System.out.println("user password " + user.getPassword());

		try {
			String hql = "from User U where U.usercode = :usercode";
			Query query = session.createQuery(hql);
			query.setParameter("user code", user.getUsercode());
			listUser = query.list();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return listUser;
	}

	/**
	 * Used to list a single user by Id.
	 */
	@Override
	public User listUserById(Long userid) {
		User user = null;
		try {
			user = (User) session.get(User.class, userid);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return user;
	}

}

