/*
	File : Customer.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 17/01/2014
	Source : 
	Notes : 
*/
package org.model;

import java.util.HashSet;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Customer generated by hbm2java
 */
@Entity
@Table(name = "customer", catalog = "scart1")
public class Customer implements java.io.Serializable {

	private static final long serialVersionUID = 1L;

	private Long custid;
	private User user;
	private String cardname;
	private String cardcode;
	private String carcode2;
	private String carcode3;
	private String notes;
	private Set<Orders> orderses = new HashSet<Orders>(0);

	public Customer() {
	}

	public Customer(User user, String cardname, String cardcode,
			String carcode2, String carcode3, String notes) {
		this.user = user;
		this.cardname = cardname;
		this.cardcode = cardcode;
		this.carcode2 = carcode2;
		this.carcode3 = carcode3;
		this.notes = notes;
	}

	public Customer(User user, String cardname, String cardcode,
			String carcode2, String carcode3, String notes, Set<Orders> orderses) {
		this.user = user;
		this.cardname = cardname;
		this.cardcode = cardcode;
		this.carcode2 = carcode2;
		this.carcode3 = carcode3;
		this.notes = notes;
		this.orderses = orderses;
	}

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "custid", unique = true, nullable = false)
	public Long getCustid() {
		return this.custid;
	}

	public void setCustid(Long custid) {
		this.custid = custid;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "numberiduser", nullable = false)
	public User getUser() {
		return this.user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	@Column(name = "cardname", nullable = false, length = 40)
	public String getCardname() {
		return this.cardname;
	}

	public void setCardname(String cardname) {
		this.cardname = cardname;
	}

	@Column(name = "cardcode", nullable = false, length = 40)
	public String getCardcode() {
		return this.cardcode;
	}

	public void setCardcode(String cardcode) {
		this.cardcode = cardcode;
	}

	@Column(name = "carcode2", nullable = false, length = 40)
	public String getCarcode2() {
		return this.carcode2;
	}

	public void setCarcode2(String carcode2) {
		this.carcode2 = carcode2;
	}

	@Column(name = "carcode3", nullable = false, length = 40)
	public String getCarcode3() {
		return this.carcode3;
	}

	public void setCarcode3(String carcode3) {
		this.carcode3 = carcode3;
	}

	@Column(name = "notes", nullable = false, length = 40)
	public String getNotes() {
		return this.notes;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "customer")
	public Set<Orders> getOrderses() {
		return this.orderses;
	}

	public void setOrderses(Set<Orders> orderses) {
		this.orderses = orderses;
	}

}
