/*
	Project : MARCEL_CRUD_2
	File : SCartDetail.java
	Author : MSA
	Date : 25/12/2013
	Source : http://struts.apache.org/release/2.0.x/docs/simplelogin-with-session.html
			 http://www.java4s.com/struts-tutorials/example-on-struts-2-sessionaware-interface/
			 http://viralpatel.net/blogs/struts-displaytag-tutorial-sort-pagination-data-displaytag-struts/comment-page-1/
	Notes : Use SessionAware, model master-detail shopping cart fixed data, and his item's lines
*/
package org.model;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Iterator;

public class SCartDetail {

	private Long id;
	private Long codeProduct;
	private String nameProduct;
	private String nameImage;
	private float quantity;
	private float pcntDiscount;
	private double discount;
	private double price;
	private double totalLine;

	public SCartDetail() {

	}

	public SCartDetail( Long id,
						Long codeProduct,
						String nameProduct,
						String nameImage,
						float quantity,
						float pcntDiscount,
						double discount,
						double price,
						double totalLine) {
		this.id = id;
		this.codeProduct = codeProduct;
		this.nameProduct = nameProduct;
		this.nameImage = nameImage;
		this.quantity = quantity;
		this.pcntDiscount = pcntDiscount;
		this.discount = discount;
		this.price = price;
		this.totalLine = totalLine;
	}

	public ArrayList<SCartDetail> addLineToSCart(ArrayList<SCartDetail> scartList) {
		Long lastId = readLastIdSCart(scartList);
		lastId = lastId + 1;
		scartList.add(new SCartDetail(lastId,
									  codeProduct,
									  nameProduct,
									  nameImage,
									  quantity,
									  pcntDiscount,
									  discount,
									  price,
									  totalLine));
		return scartList;
	}


	public Long readLastIdSCart(ArrayList<SCartDetail> scartList) {

		System.out.println("");
		System.out.println("SCartdetail.java : readLastIdSCart");

		Long lastId = 0L;

		Iterator<SCartDetail> iter = scartList.iterator();
		while (iter.hasNext()) {
			SCartDetail lineSCart = iter.next();
			if (lastId < lineSCart.getId()) {
				lastId = lineSCart.getId();
			}
		}

		// Print item's number
		System.out.println("");
		System.out.println("------------------------------------------------------");
		System.out.println("Last *Id* in SCart : " + lastId);
		System.out.println("------------------------------------------------------");

		return lastId;
	}


	public double totalizeSCart(ArrayList<SCartDetail> scartList) {
		double total = 0;

		System.out.println("");
		System.out.println("SCartdetail.java : SCart Detail");
		System.out.println("----------------------------------");

		Iterator<SCartDetail> iter = scartList.iterator();
		while (iter.hasNext()) {
			SCartDetail lineSCart = iter.next();

			total = total + lineSCart.getTotalLine();

			NumberFormat numberFormatter = new DecimalFormat("####.00");
			String resQuantity = numberFormatter.format(lineSCart.getQuantity());
			String resPcntDiscount = numberFormatter.format(lineSCart.getPcntDiscount());
			String resDiscount = numberFormatter.format(lineSCart.getDiscount());
			String resPrice = numberFormatter.format(lineSCart.getPrice());
			String resTotalLine = numberFormatter.format(lineSCart.getTotalLine());

			System.out.println("Ticket's line data :" +
								" id : " + lineSCart.getId() +
								", codeProduct : " + lineSCart.getCodeProduct() +
								", nameProduct : " + lineSCart.getNameProduct() +
								", nameImage : " + lineSCart.getNameImage() +
								", quantity : " + resQuantity +
								", pcntDiscount : " + resPcntDiscount +
								", discount : " + resDiscount +
								", price : " + resPrice +
								", totalLine : " + resTotalLine); 
		}

		// Print total
		System.out.println("");
		System.out.println("SCartDetail.java -------------------------------------");
		System.out.println("Total shopping cart : " + total);
		System.out.println("------------------------------------------------------");
		System.out.println("");

		return total;
	}


	public int countItemsSCart(ArrayList<SCartDetail> scartList) {

		System.out.println("");
		System.out.println("SCartdetail.java : countItemsSCart");

		int counter = 0;

		Iterator<SCartDetail> iter = scartList.iterator();
		while (iter.hasNext()) {
			iter.next();
			counter++;
		}

		// Print item's number
		System.out.println("");
		System.out.println("------------------------------------------------------");
		System.out.println("Item's number : " + counter);
		System.out.println("------------------------------------------------------");

		return counter;
	}


	public ArrayList<SCartDetail> deleteSCart() {
		ArrayList<SCartDetail> scartList = new ArrayList<SCartDetail>();
		return scartList;
	}


	public ArrayList<SCartDetail> loadSCartTest() {
		ArrayList<SCartDetail> scartList = new ArrayList<SCartDetail>();
		scartList.add(new SCartDetail(1L, 1L, "Product 1", "/img/Image01.png", (float) 1.0, (float) 0.0, 0.0, 1.0, 1.0));
		scartList.add(new SCartDetail(2L, 2L, "Product 2", "/img/Image02.png", (float) 2.0, (float) 0.0, 0.0, 1.0, 2.0));
		scartList.add(new SCartDetail(3L, 3L, "Product 3", "/img/Image03.png", (float) 3.0, (float) 0.0, 0.0, 1.0, 3.0));
		scartList.add(new SCartDetail(4L, 4L, "Product 4", "/img/Image04.png", (float) 4.0, (float) 0.0, 0.0, 1.0, 4.0));
//		scartList.add(new SCartDetail(5L, 5, "Product 5", "/img/Image05.png", (float) 5.0, (float) 0.0, 0.0, 1.0, 5.0));
//		scartList.add(new SCartDetail(6L, 6, "Product 6", "/img/Image06.png", (float) 6.0, (float) 0.0, 0.0, 1.0, 6.0));
//		scartList.add(new SCartDetail(7L, 7, "Product 7", "/img/Image07.png", (float) 7.0, (float) 0.0, 0.0, 1.0, 7.0));
//		scartList.add(new SCartDetail(8L, 8, "Product 8", "/img/Image08.png", (float) 8.0, (float) 0.0, 0.0, 1.0, 8.0));
//		scartList.add(new SCartDetail(9L, 9, "Product 9", "/img/Image09.png", (float) 9.0, (float) 0.0, 0.0, 1.0, 9.0));
//		scartList.add(new SCartDetail(10L, 10, "Product 10", "/img/Image10.png", (float) 10.0, (float) 0.0, 0.0, 1.0, 10.0));
//		scartList.add(new SCartDetail(11L, 11, "Product 11", "/img/Image11.png", (float) 11.0, (float) 0.0, 0.0, 1.0, 11.0));
//		scartList.add(new SCartDetail(12L, 12, "Product 12", "/img/Image12.png", (float) 12.0, (float) 0.0, 0.0, 1.0, 12.0));
//		scartList.add(new SCartDetail(13L, 13, "Product 13", "/img/Image13.png", (float) 13.0, (float) 0.0, 0.0, 1.0, 13.0));
//		scartList.add(new SCartDetail(14L, 14, "Product 14", "/img/Image14.png", (float) 14.0, (float) 0.0, 0.0, 1.0, 14.0));
//		scartList.add(new SCartDetail(15L, 15, "Product 15", "/img/Image15.png", (float) 15.0, (float) 0.0, 0.0, 1.0, 15.0));
//		scartList.add(new SCartDetail(16L, 16, "Product 16", "/img/Image16.png", (float) 16.0, (float) 0.0, 0.0, 1.0, 16.0));
//		scartList.add(new SCartDetail(17L, 17, "Product 17", "/img/Image17.png", (float) 17.0, (float) 0.0, 0.0, 1.0, 17.0));
//		scartList.add(new SCartDetail(18L, 18, "Product 18", "/img/Image18.png", (float) 18.0, (float) 0.0, 0.0, 1.0, 18.0));
//		scartList.add(new SCartDetail(19L, 19, "Product 19", "/img/Image19.png", (float) 19.0, (float) 0.0, 0.0, 1.0, 19.0));
		return scartList;
	}


	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public Long getCodeProduct() {
		return codeProduct;
	}
	public void getCodeProduct(Long codeProduct) {
		this.codeProduct = codeProduct;
	}
	public String getNameProduct() {
		return nameProduct;
	}
	public void getNameProduct(String nameProduct) {
		this.nameProduct = nameProduct;
	}
	public String getNameImage() {
		return nameImage;
	}
	public void setNameImage(String nameImage) {
		this.nameImage = nameImage;
	}
	public float getQuantity() {
		return quantity;
	}
	public void setQuantity(float quantity) {
		this.quantity = quantity;
	}
	public float getPcntDiscount() {
		return pcntDiscount;
	}
	public void setPcntDiscount(float pcntDiscount) {
		this.pcntDiscount = pcntDiscount;
	}
	public double getDiscount() {
		return discount;
	}
	public void setDiscount(double discount) {
		this.discount = discount;
	}
	public double getPrice() {
		return price;
	}
	public void setPrice(double price) {
		this.price = price;
	}
	public double getTotalLine() {
		return totalLine;
	}
	public void setTotalLine(double totalLine) {
		this.totalLine = totalLine;
	}

}


