/*
	File : SCartMaster.java
	Project : MARCEL_CRUD_2
	Author : MSA
	Date : 25/12/2013
	Source : http://cafelojano.wordpress.com/2007/11/21/transformando-string-a-date-uso-de-simpledateformat/
			 http://www.roseindia.net/java/beginners/RoundTwoDecimalPlaces.shtml
			 http://www.javabeat.net/precise-rounding-of-decimals-using-rounding-mode-enumeration/
			 IMPORTANT : http://stackoverflow.com/questions/2808535/round-a-double-to-2-decimal-places
	Notes :
*/
package org.model;

//import java.math.BigDecimal;
import java.text.ParseException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.ArrayList;
//import java.util.List;




import org.model.SCartDetail;

public class SCartMaster {
	private int invoiceId;
	private int custId;
	private String custName;
	private String cardName;
	private String cardCode;
	private Date dateSCart;
	private double totalLines;
	private int counterItems;
	private float pcntDiscount1;
	private double discount1;
	private float pcntDiscount2;
	private double discount2;
	private float pcntDiscount3;
	private double discount3;
	private float pcntTax;
	private double tax;
	private double totalSCart;

	private ArrayList<SCartDetail> sCartDetail;

	public SCartMaster() {

	}

	// ---------------------------------------------------------------------------
	// Create a new SCart --------------------------------------------------------
	// ---------------------------------------------------------------------------
	public void createNewSCart() {
		System.out.println("");
		System.out.println("SCartMaster.java");
		System.out.println("method : createNewSCart");

		// Ticket head's data ----------------------------------------------------
		this.invoiceId = 150;
		this.custId = 5;
		this.custName = "Client numero 5";
		this.cardName = "VIXA";
		this.cardCode = "a234b567";

		// Today's date of Ticket ------------------------------------------------
		//DateFormat formatDate2 = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		DateFormat formatDate2 = new SimpleDateFormat("yyyy/MM/dd");
		Date date2 = new Date();
		try {
			date2 = formatDate2.parse(formatDate2.format(new Date()));
		} catch (ParseException ex) {
			ex.printStackTrace();
		}
		System.out.println("Data d'avui: " + formatDate2.format(new Date()));
		this.dateSCart = date2;

		// Initialize percentages ------------------------------------------------
		this.pcntDiscount1 = 0.0f; // 15.0f;
		this.pcntDiscount2 = 0.0f;
		this.pcntDiscount3 = 0.0f;
		this.discount1 = 0.0;
		this.discount2 = 0.0;
		this.discount3 = 0.0;
		this.pcntTax = 21.0f;
		// -----------------------------------------------------------------------

		// Initialize a new SCart Detail -----------------------------------------
		ArrayList<SCartDetail> sCartDetail = new ArrayList<SCartDetail>();
		this.sCartDetail = sCartDetail;

		System.out.println("method : createNewSCart FINAL");
	}


	public void addNewLineToSCart(Long id,
								  Long codeProduct,
								  String nameProduct,
								  String nameImage,
								  float quantity,
								  float pcntDiscount,
								  double discount,
								  double price,
								  double totalLine) {
		SCartDetail sCartDetail = new SCartDetail(id,
												  codeProduct,
												  nameProduct,
												  nameImage,
												  quantity,
												  pcntDiscount,
												  discount,
												  price,
												  totalLine);
		// Returns the Complete list with the last line added
		this.sCartDetail = sCartDetail.addLineToSCart(this.sCartDetail);

		// Totalize SCart
		totalizeSCart();
		
	}


	// ---------------------------------------------------------------------------
	// Totalize SCart ------------------------------------------------------------
	// ---------------------------------------------------------------------------
	public void totalizeSCart() {
		double calculator = 0.0;
		double amount = 0.0;

		// Initialize a new SCart Detail for two calculations --------------------
		SCartDetail sCD = new SCartDetail();

		// Calculate Ticket's Total Lines ----------------------------------------
		this.totalLines = sCD.totalizeSCart(this.sCartDetail);

		// Calculate Ticket Lines's number ---------------------------------------
		this.counterItems = sCD.countItemsSCart(this.sCartDetail);

		// Calculate Ticket's Lines ----------------------------------------------
		// System.out.println("");
		System.out.println("Total de linies del ticket (amount) : " + this.totalLines);
		System.out.println("----------------------------- Items # " + this.counterItems);
		System.out.println("");

		// Intitialize amount's Ticket -------------------------------------------
		amount = this.totalLines;

		// Calculate total's ticket ----------------------------------------------
		// Subtract the discounts
		if (this.pcntDiscount1 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount1 / 100.0, 2);
			amount = amount - calculator;
			this.discount1 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount1 " + this.pcntDiscount1);
			System.out.println("--- Discount1 " + this.discount1);
		}

		if (this.pcntDiscount2 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount2 / 100.0, 2);
			amount = amount - calculator;
			this.discount2 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount2 " + this.pcntDiscount2);
			System.out.println("--- Discount2 " + this.discount2);
		}

		if (this.pcntDiscount3 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount3 / 100.0, 2);
			amount = amount - calculator;
			this.discount3 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount3 " + this.pcntDiscount3);
			System.out.println("--- Discount3 " + this.discount3);
		}

		// Add the tax
		if (this.pcntTax != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntTax / 100.0, 2);
			amount = amount + calculator;
			this.tax = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntTax " + this.pcntTax);
			System.out.println("--- Tax " + this.tax);
		}

		amount = (double) RoundDouble (amount, 2);

		 this.totalSCart = amount;
		//this.totalSCart = (double) RoundDouble (amount, 2);
		System.out.println("---  " + this.totalSCart);

		// Print the head's Ticket -----------------------------------------------
		System.out.println("");
		System.out.println("Invoice id : " + this.invoiceId);
		System.out.println("Customer id : " + this.custId);
		DateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");
		String s = formatter.format(this.dateSCart);
		System.out.println("Date Invoice: " + s);
		System.out.println("Customer name : " + this.custName);
		System.out.println("Card name : " + this.cardName);
		System.out.println("Card code : " + this.cardCode);

		// Print the foot's Ticket -----------------------------------------------
		System.out.println("");
		System.out.println("Acumulat : " + this.totalSCart);
		System.out.println("% descompte : " + this.pcntDiscount1);
		System.out.println("Import Descompte : " + this.discount1);
		System.out.println("% IVA : " + this.pcntTax);
		System.out.println("Import IVA : " + this.tax);
		System.out.println("");
		System.out.println("-----------------------------------");
		System.out.println("Total Ticket " + this.totalSCart);
		System.out.println("-----------------------------------");

	}


	
	// ---------------------------------------------------------------------------
	// Load the hard-coded SCart in SCartDetail for test purposes ----------------
	// ---------------------------------------------------------------------------
	public void createSCartTest() {
		double calculator = 0.0;
		double amount = 0.0;

		// Initialize a new SCart Detail -----------------------------------------
		SCartDetail sCartDetail = new SCartDetail();
		this.sCartDetail = sCartDetail.loadSCartTest();

		// Calculate Ticket's Total Lines ----------------------------------------
		this.totalLines = sCartDetail.totalizeSCart(this.sCartDetail);

		// Calculate Ticket Lines's number ---------------------------------------
		this.counterItems = sCartDetail.countItemsSCart(this.sCartDetail);

		// Calculate Ticket's Lines ----------------------------------------------
		// System.out.println("");
		System.out.println("Total de linies del ticket : " + this.totalLines);
		System.out.println("");

		// Intitialize amount's Ticket -------------------------------------------
		amount = this.totalLines;

		// Ticket head's data ----------------------------------------------------
		this.invoiceId = 150;
		this.custId = 5;
		this.custName = "Client numero 5";
		this.cardName = "VILLA";
		this.cardCode = "a234b567";

		// Date Format : yyyy-MM-ddd ---------------------------------------------
		SimpleDateFormat formatDate = new SimpleDateFormat("yyyy-MM-dd");
		String strDate = "2013-12-25";
		Date date = null;
		try {
			date = formatDate.parse(strDate);
		} catch (ParseException ex) {
			ex.printStackTrace();
		}
		this.dateSCart = date;

		// Initialize percentages ------------------------------------------------
		this.pcntDiscount1 = 15.0f;
		this.pcntDiscount2 = 0.0f;
		this.pcntDiscount3 = 0.0f;
		this.discount1 = 0.0;
		this.discount2 = 0.0;
		this.discount3 = 0.0;
		this.pcntTax = 21.0f;
		// -----------------------------------------------------------------------

		System.out.println("-- Items # " + this.counterItems);
		System.out.println("--- Amount " + amount);

		// Calculate total's ticket ----------------------------------------------
		// Subtract the discounts
		if (this.pcntDiscount1 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount1 / 100.0, 2);
			amount = amount - calculator;
			this.discount1 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount1 " + this.pcntDiscount1);
			System.out.println("--- Discount1 " + this.discount1);
		}

		if (this.pcntDiscount2 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount2 / 100.0, 2);
			amount = amount - calculator;
			this.discount2 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount2 " + this.pcntDiscount2);
			System.out.println("--- Discount2 " + this.discount2);
		}

		if (this.pcntDiscount3 != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntDiscount3 / 100.0, 2);
			amount = amount - calculator;
			this.discount3 = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntDiscount3 " + this.pcntDiscount3);
			System.out.println("--- Discount3 " + this.discount3);
		}

		// Add the tax
		if (this.pcntTax != 0.0f ) {
			calculator = (double) RoundDouble (amount * this.pcntTax / 100.0, 2);
			amount = amount + calculator;
			this.tax = calculator;
			System.out.println("");
			System.out.println("--- Amount " + amount);
			System.out.println("--- pcntTax " + this.pcntTax);
			System.out.println("--- Tax " + this.tax);
		}

		amount = (double) RoundDouble (amount, 2);

		 this.totalSCart = amount;
		//this.totalSCart = (double) RoundDouble (amount, 2);
		System.out.println("---  " + this.totalSCart);

		// Print the head's Ticket -----------------------------------------------
		System.out.println("");
		System.out.println("Invoice id : " + this.invoiceId);
		System.out.println("Customer id : " + this.custId);
		DateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");
		String s = formatter.format(this.dateSCart);
		System.out.println("Date Invoice: " + s);
		System.out.println("Customer name : " + this.custName);
		System.out.println("Card name : " + this.cardName);
		System.out.println("Card code : " + this.cardCode);

		// Print the foot's Ticket -----------------------------------------------
		System.out.println("");
		System.out.println("Acumulat : " + this.totalSCart);
		System.out.println("% descompte : " + this.pcntDiscount1);
		System.out.println("Import Descompte : " + this.discount1);
		System.out.println("% IVA : " + this.pcntTax);
		System.out.println("Import IVA : " + this.tax);
		System.out.println("");
		System.out.println("-----------------------------------");
		System.out.println("Total Ticket " + this.totalSCart);
		System.out.println("-----------------------------------");

	}


	// ---------------------------------------------------------------------------
	// Round Double function -----------------------------------------------------
	// ---------------------------------------------------------------------------
	public static double RoundDouble(double Rval, int Rpl) {
		double p = (double) Math.pow(10, Rpl);
		Rval = Rval * p;
		double tmp = Math.round(Rval);
		return (double) tmp / p;
	}


	public int getInvoiceId() {
		return invoiceId;
	}
	public void setInvoiceId(int invoiceId) {
		this.invoiceId = invoiceId;
	}
	public int getCustId() {
		return custId;
	}
	public void setCustId(int custId) {
		this.custId = custId;
	}
	public String getCustName() {
		return custName;
	}
	public void setCustName(String custName) {
		this.custName = custName;
	}
	public String getCardName() {
		return cardName;
	}
	public void setCardName(String cardName) {
		this.cardName = cardName;
	}
	public String getCardCode() {
		return cardCode;
	}
	public void setCardCode(String cardCode) {
		this.cardCode = cardCode;
	}
	public Date getDateSCart() {
		return dateSCart;
	}
	public void setDateSCart(Date dateSCart) {
		this.dateSCart = dateSCart;
	}
	public double getTotalLines() {
		return totalLines;
	}
	public void setTotalLines(double totalLines) {
		this.totalLines = totalLines;
	}
	public int getCounterItems() {
		return counterItems;
	}
	public void setCounterItems(int counterItems) {
		this.counterItems = counterItems;
	}
	public float getPcntDiscount1() {
		return pcntDiscount1;
	}
	public void setPcntDiscount1(float pcntDiscount1) {
		this.pcntDiscount1 = pcntDiscount1;
	}
	public double getDiscount1() {
		return discount1;
	}
	public void setDiscount1(double discount1) {
		this.discount1 = discount1;
	}
	public float getPcntDiscount2() {
		return pcntDiscount2;
	}
	public void setPcntDiscount2(float pcntDiscount2) {
		this.pcntDiscount2 = pcntDiscount2;
	}
	public double getDiscount2() {
		return discount2;
	}
	public void setDiscount2(double discount2) {
		this.discount2 = discount2;
	}
	public float getPcntDiscount3() {
		return pcntDiscount3;
	}
	public void setPcntDiscount3(float pcntDiscount3) {
		this.pcntDiscount3 = pcntDiscount3;
	}
	public double getDiscount3() {
		return discount3;
	}
	public void setDiscount3(double discount3) {
		this.discount3 = discount3;
	}
	public float getPcntTax() {
		return pcntTax;
	}
	public void setPcntTax(float pcntTax) {
		this.pcntTax = pcntTax;
	}
	public double getTax() {
		return tax;
	}
	public void setTax(double tax) {
		this.tax = tax;
	}
	public double getTotalSCart() {
		return totalSCart;
	}
	public void setTotalScart(double totalSCart) {
		this.totalSCart = totalSCart;
	}
	public ArrayList<SCartDetail> getSCartDetail() {
		return sCartDetail;
	}
	public void setSCartDetail(ArrayList<SCartDetail> sCartDetail) {
		this.sCartDetail = sCartDetail;
	}

	public String toString() {
		return custName + " (SCartMaster from toString)";
	}

}


