/*
	Project : MARCEL_SESSION_2
	File : SCartSession.java
	Author : MSA
	Date : 25/12/2013
	Source : http://struts.apache.org/release/2.0.x/docs/simplelogin-with-session.html
			 http://www.java4s.com/struts-tutorials/example-on-struts-2-sessionaware-interface/
			 http://viralpatel.net/blogs/struts-displaytag-tutorial-sort-pagination-data-displaytag-struts/comment-page-1/
	Notes : Uses SessionAware
*/
package org.scart.session;

import java.util.ArrayList;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import com.opensymphony.xwork2.ActionSupport;

import org.model.SCartDetail;
import org.model.SCartMaster;


public class SCartSession extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 1L;

	// Required by SessionAware class.
	Map<String, Object> m;

	private SCartMaster sCartMaster;

	// Required by SessionAware class.
	public void setSession(Map<String, Object> m) {
		this.m = m;
	}


	public String execute() throws Exception {
		return SUCCESS;
	}


	//---------------------------------------------------------------
	// Create SCart in the session ----------------------------------
	//---------------------------------------------------------------
	public String createSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : createSCartSession : crea un SCart a la sessio");

		if (sCartMaster == null) {
			sCartMaster = new SCartMaster();
			System.out.println("");
			System.out.println("SCartSession.java");
			System.out.println("method createSCartSession -----------");
			System.out.println("sCartMaster.getCustId() " + sCartMaster.getCustId() );
			System.out.println("sCartMaster.getCustName() " + sCartMaster.getCustName() );
		}

		try {
			// Create or Update the map.
			m.put("SCartMaster", sCartMaster);
			System.out.println("");
			System.out.println("SCart CREATE *fet* a la sessio");
			System.out.println("");
			return SUCCESS;
		} catch (Exception e) {
			System.out.println("");
			System.out.println("SCart CREATE *NO s'ha pogut fer* a la sessio");
			System.out.println("");
			return ERROR;
		}

	}


	//---------------------------------------------------------------
	// View SCart in the session ----------------------------------
	//---------------------------------------------------------------
	public String viewSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : viewSCartSession : crea un SCart a la sessio");

		return SUCCESS;

//		if (sCartMaster == null) {
//			sCartMaster = new SCartMaster();
//			System.out.println("");
//			System.out.println("SCartSession.java");
//			System.out.println("method viewSCartSession -----------");
//			System.out.println("sCartMaster.getCustId() " + sCartMaster.getCustId() );
//			System.out.println("sCartMaster.getCustName() " + sCartMaster.getCustName() );
//		}

//		try {
//			// Create or Update the map.
//			m.put("SCartMaster", sCartMaster);
//			System.out.println("");
//			System.out.println("SCart CREATE *fet* a la sessio");
//			System.out.println("");
//			return SUCCESS;
//		} catch (Exception e) {
//			System.out.println("");
//			System.out.println("SCart CREATE *NO s'ha pogut fer* a la sessio");
//			System.out.println("");
//			return ERROR;
//		}

	}


	//---------------------------------------------------------------
	// Update SCart line in the session -----------------------------
	//---------------------------------------------------------------
	public String updateSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : updateSCartSession : alta/modifica SCart lines a la sessio");

		if (sCartMaster == null) {
			sCartMaster = new SCartMaster();
			System.out.println("");
			System.out.println("SCartSession.java");
			System.out.println("method updateSCartSession -----------");
			System.out.println("sCartMaster.getCustId() " + sCartMaster.getCustId() );
			System.out.println("sCartMaster.getCustName() " + sCartMaster.getCustName() );
		}

		try {
			// Create or Update the map.
			m.put("SCartMaster", sCartMaster);
			System.out.println("");
			System.out.println("SCart UPDATE *fet* a la sessio");
			System.out.println("");
			return SUCCESS;
		} catch (Exception e) {
			System.out.println("");
			System.out.println("SCart UPDATE *NO s'ha pogut fer* a la sessio");
			System.out.println("");
			return ERROR;
		}

	}


	//---------------------------------------------------------------
	// Delete SCart line in the session -----------------------------
	//---------------------------------------------------------------****
	public String deleteLinesSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : deleteLinesSCartSession : esborra una linia SCart de la sessio");

		try {
			// Remove the map.
			SCartMaster sCartMaster = (SCartMaster) m.get("SCartMaster"); 
			System.out.println("");
			System.out.println("method : deleteLinesSCartSession : linia de SCart de la sessio esborrada ");
			System.out.println("");

			// Delete line number 1 in the SCart.
			int line = 1;
			sCartMaster.getSCartDetail().remove(line);

			// Initialize a new SCart Detail -----------------------------------------
			SCartDetail sCartDetail = new SCartDetail();
			ArrayList<SCartDetail> listSCartDetail = sCartMaster.getSCartDetail();

			// Calculate Ticket's Total Lines ----------------------------------------
			sCartMaster.setTotalLines(sCartDetail.totalizeSCart(listSCartDetail));

			// Calculate Ticket Lines's number ---------------------------------------
			sCartMaster.setCounterItems(sCartDetail.countItemsSCart(listSCartDetail));

			// Calculate Ticket Lines's number ---------------------------------------
			sCartMaster.setCounterItems(sCartDetail.countItemsSCart(listSCartDetail));
			System.out.println("method : deleteLinesSCartSession     pas 1 ");

			// Create or Update the map.
			m.put("SCartMaster", sCartMaster);
			System.out.println("method : deleteLinesSCartSession     pas 2 ");
			System.out.println("");
			System.out.println("SCart deleteLinesSCartSession *fet* a la sessio");
			return SUCCESS;
		} catch (Exception e) {
			return ERROR;
		}
	}


	//---------------------------------------------------------------
	// Delete SCart in the session ----------------------------------
	//---------------------------------------------------------------
	public String deleteSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : deleteSCartSession : esborra SCart de la sessio");

		try {
			// Remove the map.
			m.remove("SCartMaster"); 
			System.out.println("");
			System.out.println("method : deleteSCartSession : SCart esborrat de la sessio");
			System.out.println("");
			return SUCCESS;
		} catch (Exception e) {
			return ERROR;
		}
	}


	//---------------------------------------------------------------
	// Test SCart in the session ------------------------------------
	//---------------------------------------------------------------
	public String testSCartSession() throws Exception {
		System.out.println("");
		System.out.println("SCartSession.java");
		System.out.println("method : testSCartSession : comprova si SCart esta a la sessio");

		try {
			// Read the map
			@SuppressWarnings("unused")
			SCartMaster sCartMaster = (SCartMaster) m.get("SCartMaster");
			System.out.println("");
			System.out.println("method : testSCartSession : SCart esta a la sessio");
			System.out.println("");
			return SUCCESS;
		} catch (Exception e) {
			System.out.println("");
			System.out.println("SCart  NO estas a la sessio");
			System.out.println("");
			return ERROR;
		}
	}

}


