/*
	Project : MARCEL_CRUD_2
	File : AddItemToSCart.java
	Author : MSA
	Date : 25/12/2013
	Source : http://struts.apache.org/release/2.0.x/docs/simplelogin-with-session.html
			 http://www.java4s.com/struts-tutorials/example-on-struts-2-sessionaware-interface/
			 http://www.javatpoint.com/struts-2-login-and-logout-example
			 http://viralpatel.net/blogs/struts-displaytag-tutorial-sort-pagination-data-displaytag-struts/comment-page-1/
	Notes : Use SessionAware 
*/
package org.scart.update;

import java.math.BigDecimal;
import java.util.Map;
import java.util.Date;

import org.apache.struts2.interceptor.SessionAware;

import com.opensymphony.xwork2.ActionSupport;

import org.model.Item;
import org.model.SCartDetail;
import org.model.SCartMaster;


public class AddItemToSCart extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 1L;

	private Long id;
	private Long codePubliOrCol;
	private String prodorcol;
	private String title;
	private String author;
	private String edition;
	private String revision;
	private String format;
	private String nameimage;
	private BigDecimal quantity;
	private BigDecimal pcntDiscount;
	private BigDecimal price;

	private SCartMaster sCartMaster;

	Map<String, Object> m; // Session m

	public void setSession(Map<String, Object> m) {
		this.m = m;
	}

	public String execute() throws Exception {
		return SUCCESS;
	}

	public String addItemToSCartDetail() throws Exception {
		System.out.println("");
		System.out.println("AddItemToSCart.java");
		System.out.println("method : addItemToSCartDetail()");

//		System.out.println("id : " + id);
//		System.out.println("codePubliOrCol : " + codePubliOrCol);
//		System.out.println("prodorcol : " + prodorcol);
//		System.out.println("title : " + title);
//		System.out.println("author : " + author);
//		System.out.println("edition : " + edition);
//		System.out.println("revision : " + revision);
//		System.out.println("format : " + format);
//		System.out.println("nameimage : " + nameimage);
//		System.out.println("pcntDiscount : " + pcntDiscount);
//		System.out.println("price : " + price);
//		System.out.println("quantity : " + quantity);

		String a = testSCartSession();

//		System.out.println("method : addItemToSCartDetail : ENTRA Totals");

		// Calculations
		float quantityf = quantity.floatValue();
		float pcntDiscountf = pcntDiscount.floatValue();
		double totalLined = quantity.doubleValue() * price.doubleValue();
		double priced = price.doubleValue();

//		System.out.println("method : addItemToSCartDetail : FI Totals");

		// Add a new line to SCart
		this.sCartMaster.addNewLineToSCart(	0L,
											codePubliOrCol,
											title,
											nameimage,
											quantityf,
											pcntDiscountf,
											(double) 0.0,
											priced,
											totalLined);
		System.out.println("");
		System.out.println("method : addItemToSCartDetail : AFEGIDA LINIA");

		// SCartMaster updated in the session.
		m.put("SCartMaster", this.sCartMaster);
		System.out.println("method : addItemToSCartDetail : Actualitzat SCart a la Sessio ========");

		return SUCCESS;
	}

	//---------------------------------------------------------------
	// Test SCart in the session ------------------------------------
	//---------------------------------------------------------------
	public String testSCartSession() throws Exception {
		System.out.println("");
		System.out.println("AddItemToSCart.java");
		System.out.println("method : testSCartSession : comprova si SCart esta a la sessio");

		try {
			// Read the map
			SCartMaster sCM = new SCartMaster();
			sCM = (SCartMaster) m.get("SCartMaster");
			if (sCM == null) {
				System.out.println("");
				System.out.println("method : testSCartSession : SCart es NULL");
				
				SCartMaster sCM2 = new SCartMaster();
				// Create new SCart
				sCM2.createNewSCart();
				System.out.println("NUL getCustId() : " + sCM2.getCustId());
				System.out.println("NUL getCustName() : " + sCM2.getCustName());
				System.out.println("method : testSCartSession : SCart es NULL 2");

				this.sCartMaster = sCM2;
				System.out.println("method : testSCartSession : SCart es NULL 3");

//				return ERROR;
			} else {
				System.out.println("method : testSCartSession : SCart esta creat");
				System.out.println("NO NUL getCustId() : " + sCM.getCustId());
				System.out.println("NO NUL getCustName() : " + sCM.getCustName());

				this.sCartMaster = sCM;
			}

		} catch (Exception e) {
			System.out.println("");
			System.out.println("method : testSCartSession : SCart Exception");
			System.out.println("");
		}
		return SUCCESS;
	}


	public Long getId() {
		return this.id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getCodePubliOrCol() {
		return this.codePubliOrCol;
	}

	public void setCodePubliOrCol(Long codePubliOrCol) {
		this.codePubliOrCol = codePubliOrCol;
	}

	public String getTitle() {
		return this.title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getAuthor() {
		return this.author;
	}

	public void setAuthor(String author) {
		this.author = author;
	}

	public String getEdition() {
		return this.edition;
	}

	public void setEdition(String edition) {
		this.edition = edition;
	}

	public String getRevision() {
		return this.revision;
	}

	public void setRevision(String revision) {
		this.revision = revision;
	}

	public String getProdorcol() {
		return this.prodorcol;
	}

	public void setProdorcol(String prodorcol) {
		this.prodorcol = prodorcol;
	}

	public String getFormat() {
		return this.format;
	}

	public void setFormat(String format) {
		this.format = format;
	}

	public String getNameimage() {
		return this.nameimage;
	}

	public void setNameimage(String nameimage) {
		this.nameimage = nameimage;
	}

	public BigDecimal getPcntDiscount() {
		return pcntDiscount;
	}

	public void setPcntDiscount(BigDecimal pcntDiscount) {
		this.pcntDiscount = pcntDiscount;
	}

	public BigDecimal getQuantity() {
		return quantity;
	}

	public void setQuantity(BigDecimal quantity) {
		this.quantity = quantity;
	}

	public BigDecimal getPrice() {
		return price;
	}

	public void setPrice(BigDecimal price) {
		this.price = price;
	}


}


