/*
	Project : MARCEL_CRUD_2
	File : LoginAction.java
	Author : MSA
	Date : 25/12/2013
	Source : http://struts.apache.org/release/2.0.x/docs/simplelogin-with-session.html
			 http://www.java4s.com/struts-tutorials/example-on-struts-2-sessionaware-interface/
			 http://www.javatpoint.com/struts-2-login-and-logout-example
			 http://viralpatel.net/blogs/struts-displaytag-tutorial-sort-pagination-data-displaytag-struts/comment-page-1/
	Notes : Use SessionAware 
*/
package org.struts.login;

import java.util.Date;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;
import org.model.Adminuser;
import org.dao.AdminuserDAO;
import org.dao.AdminuserDAOImpl;

import com.opensymphony.xwork2.ActionSupport;

public class LoginAction extends ActionSupport implements SessionAware {

	private static final long serialVersionUID = 1L;

	private String admincode;
	private String password;
	private AdminuserDAO adminuserDAO = new AdminuserDAOImpl();

	Map<String, Object> m; // Session m

    public void setSession(Map<String, Object> m) {
        this.m = m;
    }

	public String execute() throws Exception {
    	System.out.println("");
    	System.out.println("LoginAction.java");
    	System.out.println("method : execute");
    	System.out.println("method : execute 2");
//-------------------------------------------------------------
//    	AdminuserDAO adminuserDAO = new AdminuserDAOImpl();
    	Adminuser adminuser = null;
    	adminuser.setAdmincode(admincode);
    	adminuser.setPassword(password);
    	System.out.println("method : execute 3");
    	adminuserDAO.listAdminuser();
    	//adminuserDAO.readAdminuser(adminuser);
    	if (adminuserDAO.listAdminuser().size() > 0) {

        	loginIntern(admincode, password);

    		return SUCCESS;
    	}
    	System.out.println("");
    	System.out.println("method : execute : NO estas a la sessio");
		return ERROR;
	}

	public String loginIntern(String admincode, String password) throws Exception {
    	System.out.println("");
    	System.out.println("LoginAction.java");
    	System.out.println("");
    	System.out.println("method : loginIntern : connecta a la sessio");
    	System.out.println("admincode : " + admincode);
    	System.out.println("password : " + password);
		try {
//--------------------------------------------
			m.put("admincode", admincode);
			m.put("password", password);
			m.put("date", new Date());
			m.put("brand", "El Portal");
//--------------------------------------------
			System.out.println("");
	    	System.out.println("method : login : estas a la sessio");
			return SUCCESS;
		} catch (Exception e) {
	    	System.out.println("");
	    	System.out.println("method : login : ERROR a la desconnexio de la sessio");
			return ERROR;
		}
	}

	public String login() throws Exception {
    	System.out.println("");
    	System.out.println("LoginAction.java");
    	System.out.println("");
    	System.out.println("method : login : connecta a la sessio");
    	System.out.println("admincode : " + admincode);
    	System.out.println("password : " + password);
		try {
//--------------------------------------------
			m.put("admincode", "ADMINCODE");
			m.put("password", "PASSWORD");
			m.put("date", new Date());
			m.put("brand", "El Portal");
//--------------------------------------------
			System.out.println("");
	    	System.out.println("method : login : estas a la sessio");
			return SUCCESS;
		} catch (Exception e) {
	    	System.out.println("");
	    	System.out.println("method : login : ERROR a la desconnexio de la sessio");
			return ERROR;
		}
	}

	public String logout() throws Exception {
    	System.out.println("");
    	System.out.println("LoginAction.java");
    	System.out.println("");
    	System.out.println("method : logout : desconnecta de la sessio");
		try {
//--------------------------------------------
			m.remove("admincode"); 
			m.remove("password");
			m.remove("date");
			m.remove("brand");
//--------------------------------------------
	    	System.out.println("");
	    	System.out.println("method : logout : JA NO estas a la sessio");
			return "success"; // SUCCESS;
		} catch (Exception e) {
	    	System.out.println("");
	    	System.out.println("method : logout : ERROR a la desconnexio de la sessio");
			return "error"; // ERROR;
		}
	}

	public String logtest() throws Exception {
    	System.out.println("");
    	System.out.println("LoginAction.java");
    	System.out.println("method : logtest : comprova si estas a la sessio");
		try {
//--------------------------------------------
			String admincode = m.get("admincode").toString();
			String password = m.get("password").toString();
			String date = m.get("date").toString();
			String brand = m.get("brand").toString();
//--------------------------------------------

			System.out.println("");
	    	System.out.println("admincode : " + admincode);
	    	System.out.println("password : " + password);
	    	System.out.println("date : " + date);
	    	System.out.println("brand : " + brand);

	    	System.out.println("");
	    	System.out.println("method : logtest : SÍ que estas a la sessio");
			return "success"; // SUCCESS;
		} catch (Exception e) {
	    	System.out.println("");
	    	System.out.println("method : logtest : No estas en sessio");
			return "error"; // ERROR;
		}
	}

	public String getPassword() {
		return password;
	}

	public void setPasswd(String password) {
		this.password = password;
	}

	public String getAdmincode() {
		return admincode;
	}

	public void setAdmincode(String admincode) {
		this.admincode = admincode;
	}

}

